#ifndef _STDIO_H
#include<stdio.h>
#endif
/* Debugging printf() */
#define dputs(A) fprintf(stderr,A "\n");
/* Concurrent debugging printf() */
#define tdpf(A) fprintf(stderr,A " %ld\n",pthread_self());
/* Flush the local output buffer upon exit(). */
#define exit(A) fputc('\b',stderr);fflush(stderr);exit(A)
/* Timeout for all operations. */
#define TOTAL_TIMEOUT 40
/* Timeout for an individual AXFR query. */
#define AXFR_TIMEOUT 3

void spin(void);
int chkver(const char *, const char *);
int vercmp(const char *, const char *);
int skipname(unsigned char *, unsigned char *, unsigned char *);
void vexit(const char *);
void usage(char **);


struct servers {
    char *ns;
    char *ver;
    struct servers *next;
};

struct list {
    char *num;
    struct list *next;
};

int report(struct servers *, const char *);

struct funcargs {
    unsigned long ttl;
    char *dom;
    char *bufp;
    unsigned char *cp;
    unsigned char *eom;
    void *reserved;
    unsigned short class;
    unsigned short dlen;
    unsigned short type;
};

int skiptodata(struct funcargs *);

#ifndef _NETDB_H
#include<netdb.h>
#endif
int axfrtest(struct hostent *, char *);
void *vcheck(void *);
